/*
MOCANU FLORIAN 333CA
SNAKE - PROIECT PM
*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <stdio.h>
#include <stdlib.h>
#include <util/delay.h>
#include "lcd.h"

/* main -- Program starts here */
int main(void)
{	
	//variabile ce retin date despre snake
	//starea lcd-ului 
	unsigned char snake[48][11];
	//pozitii ale sarpelui
	//dimensiunea maxima a sarperlui e stabilita la 100
	unsigned char x[100], y[100], size = 8, dir_gen, x_del, y_del, p1 = 0, p2 = 0, p3 = 0, p4 = 0;

	//variabila ce ne informa daca e prima afisare sau nu
	unsigned char count = 1;

	//variabile auxiliare
	unsigned char i, j, k, p, c, end, xbomb, ybomb, hit;

	for(i = 0 ; i < 48 ; i ++)
		for( j = 0 ; j < 11 ; j++ )
			snake[i][j] = 0x00;

	dir_gen = 0;
	snake[20][3] = 0xff;
	snake[20][5] = 0x80;
	xbomb = 48;
	ybomb = 20;
	hit = 0;

	for(i = 0 ; i < size ; i++)
	{
		y[i] = 20;
		x[size -1 - i] = 31-i;
	}

	// Setup LCD
	lcd_init();
	lcd_contrast(0x40);
	lcd_clear();

	DDRC = 0x00;
	PORTC = 0xFF;
	
	unsigned char debug = 50;
	while(1)
	{
		lcd_go_zero();
		if(bit_is_set(PINC,0))
			p1 = 1;
		if(p1 == 1 && bit_is_clear(PINC,0))
			if(dir_gen != 1)
				dir_gen = 3;
		if(bit_is_set(PINC,1))
			p2 = 1;
		if(p2 == 1 && bit_is_clear(PINC,1))
			if(dir_gen != 0)
				dir_gen = 2;
		if(bit_is_set(PINC,2))
			p3 = 1;
		if(p3 == 1 && bit_is_clear(PINC,2))
			if(dir_gen != 3)
				dir_gen = 1;
		if(bit_is_set(PINC,3))
			p4 = 1;
		if(p4 == 1 && bit_is_clear(PINC,3))
			if(dir_gen != 2)
				dir_gen = 0;
		debug --;
		if(count == 0)
		{
			//verificam daca am prins bomba
			if(x[size-1] == xbomb && y[size-1] == ybomb)	
				hit = 1;

			//realizam urmatoarea configuratie
			x_del = x[0];
			y_del = y[0];
			if(hit == 0)
			{
				//mutam sarpele in cazul in care nu a prins bomba
				for(i = 0 ; i < size - 1 ; i++)
				{
					x[i] = x[i+1];
					y[i] = y[i+1];
				}
	
				if(dir_gen == 0)	x[size-1] = (x[size-1]+1)%84;
				if(dir_gen == 1)	y[size-1] = (y[size-1]+1)%48;
				if(dir_gen == 2)	x[size-1] = x[size-1]-1 == -1 ? 83 : x[size-1]-1;
				if(dir_gen == 3)	y[size-1] = y[size-1]-1 == -1 ? 47 : y[size-1]-1;

				for(i = 0 ; i < size-1 ; i ++)
						if(x[size-1] == x[i] && y[size-1] == y[i])
						{
							i = 0xff;
							break;
						}
				if(i == 0xff)
					break;
			}
			else
			{
				//mutam sarpele cand a prins bomba
				//extindem sarpele
				size++;
				if(dir_gen == 0)	
				{
					x[size-1] = (x[size-2]+1)%84;
					y[size-1] = y[size-2];
				}
				if(dir_gen == 1)
				{
					y[size-1] = (y[size-2]+1)%48;
					x[size-1] = x[size-2];
				}
				if(dir_gen == 2)
				{
					x[size-1] = x[size-2]-1 == -1 ? 83 : x[size-2]-1;
					y[size-1] = y[size-2];
				}
				if(dir_gen == 3)
				{
					y[size-1] = y[size-2]-1 == -1 ? 47 : y[size-2]-1;
					x[size-1] = x[size-2];
				}
				//punerea unei bombe noi
				while(1)
				{
					srand(eeprom_read_dword(0));
					xbomb = rand()%84;
					int seed = (int) xbomb;
					ybomb = rand()%48;
					eeprom_write_dword(0,seed);
					seed = 1;
					for(i = 0 ; i < size ; i ++)
						if(xbomb == x[i] && ybomb == y[i])
							seed = 0;
					if(seed == 1)
						break;
				}
				j = xbomb/8;
				i = ybomb;
				k = xbomb%8;
				snake[i][j] |= (1<<k);
				i = i/8;
				i = i*8;
				c = 0x00;
				for( p = 0 ; p < 8  ; p ++)
				{
					if( snake[i+p][j] & (1<<k) )
						c |= (1<<p);
				}
				lcd_go_zero();
				lcd_goto_xy_exact(xbomb+1,i/8+1);
				lcd_put_snake(c);
			}


			//stergem ultima pozitie a sarpelui
			if(hit == 0)
			{
				j = x_del/8;
				i = y_del;
				k = x_del%8;
				snake[i][j] &= ~(1<<k);
				i = i/8;
				i = i*8;
				c = 0x00;
				for( p = 0 ; p < 8  ; p ++)
				{
					if( snake[i+p][j] & (1<<k) )
						c |= (1<<p);
				}
				lcd_go_zero();
				lcd_goto_xy_exact(x_del+1,i/8+1);
				lcd_put_snake(c);
			}
			else
				hit = 0;

			//afisam noul cap al sarpelui
			j = x[size-1]/8;
			i = y[size-1];
			k = x[size-1]%8;
			snake[i][j] |= (1<<k);
			i = i/8;
			i = i*8;
			c = 0x00;
			for( p = 0 ; p < 8  ; p ++)
			{
				if( snake[i+p][j] & (1<<k) )
					c |= (1<<p);
			}
			lcd_go_zero();
			lcd_goto_xy_exact(x[size-1]+1,i/8+1);
			lcd_put_snake(c);
		}
		else
		{
			//scoatem octetii de afisat din matrice
			for(i = 0 ; i < 48 ; i += 8)
				for(j = 0 ; j < 11 ; j ++)
				{
					if( j == 10)
						end = 4;
					else
						end = 8;
					for(k = 0 ; k < end ; k ++)
					{
						c = 0x00;
						for( p = 0 ; p < 8  ; p ++)
						{
							if( snake[i+p][j] & (1<<k) )
								c |= (1<<p);
						}
						lcd_put_snake(c);
					}
				}
			count--;
		}
		_delay_ms(100);
	}
}
